// シリアルライブラリを取り入れる
import processing.serial.*;

Serial myPort;
int x;
int y;
float r;
void setup() {
  size(1000, 1000, P2D); // 画面設定
  frameRate(100); // フレームレート60fpsにする
  background(0); // 背景色設定

  x = width / 2; // X座標を左右の中心にする
  y = height / 2; // Y座標を上限の中心にする
  r = height/3;
  myPort = new Serial(this, "/dev/tty.usbserial-FT9MF17G", 9600);

}

void draw() {
    if ( myPort.available()>=3) {  // ヘッダー,上位バイト,下位バイト 
      if ( myPort.read() == 'H' ) {  // ヘッダ文字を見つけたところから読み取る
          int val_high = myPort.read();   // 上位読み込み
          int val_low = myPort.read();   // 下位読み込み
          int t=(val_high<<8)+ val_low;

          float ct=calcT(t);
          println(ct);
          myPort.clear();
          
          float dt=ct-25;
          r=dt*150;
          if (r<50){
            r=50;
          }
          int red=(int)(255/5*dt);
          int blue=(int)(255-255/5*dt);
          fill(red,0,blue);
          drawcircle(r);
      }else{
        println(myPort.read()+"x");
      }
    }
  
    delay(50);
}

void drawcircle(float myr){
    ellipse(x,y,myr,myr);
    filter(BLUR, 6);   
     
    // 画面をフェードさせる
    blendMode(BLEND); // 塗りを線形な混色に
    fill(0,30); // 半透明の黒で塗る
    noStroke(); // 枠線なし
    rect(0, 0, width, height); // 画面全体を矩形で塗りつぶす
}

float calcT(int raw) {
  float B=3750;
  float T0=298.15;
  float R0=10000.0;
  float R1=11200.0;
  
  float rr1,t;
  rr1= R1 * raw / (1024.0 - raw);
  t = 1 / (log(rr1 / R0) / B + (1.0 / T0));
  return (float)(t - 273.15); 
}